﻿using System;
using System.Drawing;

namespace TestProject
{
    /// <summary>
    /// 실수형 포인트
    /// </summary>
    public struct DoublePoint
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// X 좌표
        /// </summary>
        private double x;

        /// <summary>
        /// Y 좌표
        /// </summary>
        private double y;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region X 좌표 - X

        /// <summary>
        /// X 좌표
        /// </summary>
        public double X
        {
            get
            {
                return this.x;
            }
            set
            {
                this.x = value;
            }
        }

        #endregion
        #region Y 좌표 - Y

        /// <summary>
        /// Y 좌표
        /// </summary>
        public double Y
        {
            get
            {
                return this.y;
            }
            set
            {
                this.y = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - DoublePoint(x, y)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="x">X 좌표</param>
        /// <param name="y">Y 좌표</param>
        public DoublePoint(double x, double y)
        {
            this.x = x;
            this.y = y;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 포인트 구하기 - GetPoint()

        /// <summary>
        /// 포인트 구하기
        /// </summary>
        /// <returns>포인트</returns>
        public Point GetPoint()
        {
            return new Point(Convert.ToInt32(this.x), Convert.ToInt32(this.y));
        }

        #endregion
        #region 사각형 구하기 - GetRectangle(width, height)

        /// <summary>
        /// 사각형 구하기
        /// </summary>
        /// <param name="width">너비</param>
        /// <param name="height">높이</param>
        /// <returns>사각형</returns>
        public Rectangle GetRectangle(int width, int height)
        {
            return new Rectangle
            (
                Convert.ToInt32(this.x) - width  / 2,
                Convert.ToInt32(this.y) - height / 2,
                width,
                height
            );
        }

        #endregion    
    }
}